<template>
  <div>
    <div class="heading">
      <h1
        v-for="creator in allCreators"
        :key="creator?._id"
        v-show="creator?._id == this.$route.params.id"
      >
        {{ creator?.name + `'s Campaign` }}
      </h1>
      <button @click="toggleCampaignForm(true)">New Campaign</button>
    </div>

    <table>
      <tr style="background: #0072ff; color: white">
        <th colspan="8">Campaign Details</th>
      </tr>
      <tr>
        <!-- Campaign Details -->
        <td>Name</td>
        <td>Type</td>
        <td>Start Date</td>
        <td>End Date</td>
        <td>Products Links</td>
        <td colspan="2">Budget</td>
      </tr>
      <tr
        v-for="campaign in getCampaigns"
        :key="campaign?._id"
        v-show="campaign?.creator_details._id == this.$route.params.id"
      >
        <td>
          {{ campaign.name }}
        </td>
        <td>
          {{ campaign.type }}
        </td>
        <td>
          {{ campaign.start_date }}
        </td>
        <td>
          {{ campaign.end_date }}
        </td>

        <td>
          <tr v-for="(product, index) in campaign.products" :key="index">
            <td>
              <a
                :href="`https://www.hypd.store/product?id=${product}`"
                target="_blank"
                >{{ `Product ` + Number(index + 1) }}</a
              >
            </td>
            <!-- <td>
              <select name="" id="" v-model="checkCreator[index]">
                <option value="">Select Option</option>
                <option value="Lavisha">Lavisha Arora</option>
                <option value="Akarshit">Akarshit Kamra</option>
                <option value="Mashiyat">Mashiyat</option>
                <option value="addnew">Add New Creator</option>
              </select>
            </td> -->
            <td>
              <select
                name="creatorstore"
                id="creatorstore"
                v-model="checkCreator[index]"
                required
              >
                <option
                  v-for="(pebble, index) in getPebbles.slice(-1, 5)"
                  :key="index"
                  :value="pebble._id"
                  :label="pebble.creator_details.name"
                  v-show="pebble.product_details._id == product"
                >
                  {{ pebble.creator_details.name }}
                </option>
                <option value="addnew">Add Creator</option>
              </select>
            </td>
            <td>
              <a
                :href="`https://www.hypd.store/product?id=${product}&creator_id=${
                  this.creatorPebble[index] ? this.creatorPebble[index] : ''
                }&pebble_id&source=creator_store`"
                target="_blank"
              >
                <button>Open Link</button>
              </a>
            </td>
            <td>
              <a
                :href="`https://www.hypd.store/product?id=${product}&creator_id=${
                  this.creatorPebble[index] ? this.creatorPebble[index] : ''
                }&pebble_id&source=creator_store`"
                @click="this.copyLink"
                id="product_link"
              >
                <button>Copy Link</button>
              </a>
            </td>
            <td v-show="checkCreator[index] == 'addnew'">
              <button>Add Product to Pebbles</button>
            </td>
          </tr>
        </td>
        <td v-show="campaign.creator_details._id == this.$route.params.id">
          {{ campaign.creator_details.budget_provided }}
        </td>
        <td><button>Share with OPS</button></td>
      </tr>
    </table>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
export default {
  data() {
    return {
      creatorPebble: [],
      checkCreator: [],
    };
  },
  methods: {
    ...mapActions([
      "fetchCreators",
      "fetchCampaigns",
      "fetchPebbles",
      "toggleCampaignForm",
      "getData",
    ]),
    copyLink(e) {
      e.preventDefault();
      let link = document.getElementById("product_link").href;

      document.addEventListener(
        "copy",
        function (e) {
          e.clipboardData.setData("text/plain", link);
          e.preventDefault();
        },
        true
      );
      document.execCommand("copy");
      alert("Link Copied: " + link);
    },
  },
  computed: mapGetters([
    "allCreators",
    "getCampaigns",
    "getPebbles",
    "createCampaign",
  ]),
  created() {
    this.getData();
    console.log(this.allCreators);
    console.log(this.getCampaigns);
    console.log(this.getPebbles);
  },
};
</script>

<style scoped>
.heading {
  display: grid;
  grid-template-columns: 50% 20% auto;
  align-items: center;
}

.heading button {
  justify-self: flex-end;
  background: #0072ff;
  border: none;
  outline: none;
  padding: 1rem;
  width: 60%;
  border-radius: 20px;
  font-weight: bold;
  color: #fff;
  cursor: pointer;
}

.heading button:hover {
  opacity: 80%;
}

select {
  border: none;
  background: none;
  outline: none;
}

button {
  background: #0072ff;
  border: 1px solid #0072ff;
  color: white;
  border-radius: 20px;
  padding: 6px;
  transition-duration: 00.3s;
  cursor: pointer;
}

button:hover {
  background: none;
  color: #0072ff;
}
</style>